# If you didn't already, check your sessionInfo()
# sessionInfo()
# R version 4.0.4 (2021-02-15)


###### 7.1 Samples and random variable


### import data from excel

male_and_female_weight <- read_excel("work/teaching/ip_hub_R_and_stats/ip_hub_R_and_stats_2022_presentiel/male_and_female_weight.xlsx")
# we need a library

# or  open file in Excel and convert in csv

mice <- read.table(file = "weights.csv")


# we need to remove header from the data 
# header = TRUE, and separator sep = ","

 mice <- read.table(file = "weights.csv", header = TRUE, sep = ",")

 # extract column sex from the mice
 
 mice_sexes <- mice$sex
 
 male_tab <- mice[mice_sexes == "M",]
 
 #sort the weights of males
 sort(male_tab$weight)

 
## From 2.2.1 Quick dive in the Milieu Intérieur dataset load the dataset mi

## histogram of ages
 
 
mi <- read.table(file = "mi.csv", header = TRUE, sep = ",", stringsAsFactors = TRUE)
ages <- mi$Age
hist(ages)


ages_short <- ages[1:20]
sort(ages_short)
median(ages_short)

which.max(table(ages))
 
hist(male_tab$weight, breaks = seq(from = 25, to = 33, by = 2))
 
hist(male_tab$weight, breaks = seq(from = 25, to = 33, by = 0.25))

hist(male_tab$weight, breaks = seq(from = 25, to = 33, by = 4))

# summary()

summary(ages)
summary(mi$HeartRate)

smoking <- mi$Smoking
summary(smoking)

# table()

table(smoking)


counts_smoking <- table(smoking)
counts_active <- counts_smoking["Active"]
counts_active

counts_inactive <- counts_smoking[c("Ex", "Never")]
counts_inactive
sum(counts_inactive)

# contingency table

table(mi$Sex, mi$Smoking)


# barplot()

barplot(counts_smoking)

sex = mi$Sex
table(sex)
barplot(table(sex))

# 
counts_smoking <- table(smoking)
nb_observations <- sum(counts_smoking)
nb_observations

proportions_smoking <- counts_smoking / nb_observations
proportions_smoking

#Bernoulli
sex_counts <- table(sex)
nb_females <- sex_counts["Female"]
prop_females <- nb_females / sum(sex_counts)
prop_females

# or 
prop.table(table(sex))



## Continuous distributions

hist(male_tab$weight, breaks = seq(from = 25, to = 33, by = 2))
plot(density(male_tab$weight))

# Normal distribution
ten_norm <- rnorm(10)
ten_norm
hist(ten_norm)
mean(ten_norm)

hundred_norm <- rnorm(100)
hist(hundred_norm)
mean(hundred_norm)

ten_norm_2 <- rnorm(10, mean = -4, sd = 0.1)
ten_norm_2
hist(ten_norm_2)
plot(density(ten_norm_2))


# Binomial

?rbinom
 
flip_5_32 <- rbinom(320, size = 5, prob = 0.5)
barplot(table(flip_5_32))

# Poisson distribution
?rpois

### MEAN & MEDIAN
mean(ages)
mean(ages > 30)
mean(ages[ages >= 64])

# calculating median step by step
ages_toy <- c(34, 4, 18, 5, 56, 41, 23, 101)
max(ages_toy) - min(ages_toy)
range(ages_toy)

length(ages_toy)
sort(ages_toy)
half_len <- length(ages_toy) / 2
mean(sort(ages_toy)[c(half_len, half_len + 1)])

# or calling a function
median(ages_toy)
mean(ages)
median(ages)

ages_wrong <- c(34, 4, 18, 5, 560, 41, 23, 101)

powers <- c(1, 2, 4, 16, 256)
median(powers)


### which()

which(ages == min(ages))
which(ages == max(ages))
max(ages)

# mode of Heart Rate

mi$HeartRate

min(mi$HeartRate)
max(mi$HeartRate)

barplot(table(mi$HeartRate))


table(mi$HeartRate)
which.max(table(mi$HeartRate))

index = which.max(table(mi$HeartRate))
table(mi$HeartRate)[index]

### Dispersion

var(ages) # variance
sd(ages) #standard deviation
sqrt(var(ages))


male_tab <- mice[mice$sex == "M",]

male_tab$weight

### standardisation -->> mean to 0 and sd to 1
###  (X - mean)/sd

mean_weight <- mean(male_tab$weight)
sd_weight <- sd(male_tab$weight)

standardized_weights <- (male_tab$weight - mean_weight) / sd_weight

hist(male_tab$weight, breaks = seq(23, 35, 3))
hist(standardized_weights, breaks = seq(-3, 3, 2))

plot(density(male_tab$weight))

plot(density(standardized_weights))

mean(standardized_weights)
sd(standardized_weights)


### Quantiles

plot(density(male_tab$weight))

quantile(male_tab$weight, 0.25) # 1st quartile
quantile(male_tab$weight, 0.5)  # median
quantile(male_tab$weight, 0.75) # 3rd quartile

quantile(male_tab$weight, c(0.25, 0.5, 0.75))

quantile(ages)
age_quartiles <- quantile(ages)
age_quartiles["50%"]

## Extract a subset of age_quartiles containing only these two extreme values.
age_quartiles[c(1,length(age_quartiles))]
age_quartiles[c("0%", "100%")]

summary(ages)

### interquartile range
age_quartiles <- quantile(ages)
iqr_ages = age_quartiles["75%"] - age_quartiles["25%"]
iqr_ages



## or use summary()
iqr_ages <- summary(ages)["3rd Qu."] - summary(ages)["1st Qu."]
iqr_ages

names(iqr_ages) <- NULL
iqr_ages

## or use the function
IQR(ages)


#### Exercise
## filter out outliers from 
 # our ages_wrong small vector example, 
 # into an ages_better vector

ages_wrong <- c(34, 4, 18, 5, 560, 41, 23, 101)


ages_wrong

iqr_wrong = IQR(ages_wrong)
iqr_wrong

Q1 = quantile(ages_wrong)["25%"]
Q3 = quantile(ages_wrong)["75%"]
names(Q1) <- NULL
names(Q3) <- NULL
Q1
Q3

lower_ok <- Q1 - 1.5 * iqr_wrong
upper_ok <- Q3 + 1.5 * iqr_wrong

lower_ok
upper_ok


age_not_outlier <- (lower_ok <= ages_wrong) & (ages_wrong <= upper_ok)
ages_better <- ages_wrong[age_not_outlier]
ages_better

boxplot(ages_wrong)
ages_wrong

boxplot(ages_better)
ages_better

### Theoretical quantiles

## Normal
qnorm(p = c(.25, .5, .75), mean = 0, sd = 1)

qnorm(c(0.25, 0.5, 0.75), mean = 2, sd = 1.5)



qnorm(c(0.025, 0.975), mean = 0, sd = 1)

## Uniform
qunif(0.75, min = 0, max=2 )



### Nice plotting
hist(ages)

hist(ages, main = "Histogram", xlab = "AGES", ylab = "Count")

hist(ages, freq = TRUE)

hist(ages, freq = FALSE)

hist(ages, freq = TRUE, col = "lightblue")

hist(ages, freq = TRUE, col = "lightblue", xlim = c(40, 60 ))

plot(ages, xlab = "individuals", ylab = "Ages", col = "blue")


### Missing values and table function
my_vector<-as.factor(mice$sex)
table(my_vector)
length(my_vector)<-length(my_vector) + 5
table(my_vector)
summary(my_vector)
table(my_vector, exclude = NULL)




